#ifndef __LIST_h__
#define __LIST_h__

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

// goal: to make a "linked list" of elements in C
typedef struct __node_t node_t;
typedef struct __list_t list_t;
typedef void (*list_iterator_t)(int);

// node_t -- holds elements of list
struct __node_t {
    int key;	
    node_t* next;
};

// list_t -- one of these per list
struct __list_t {
    node_t* head;
};

void list_init(list_t* l);
void list_insert(list_t* l, int key);
void list_insert_back(list_t* l, int key);
void list_delete(list_t* l, int key);
void list_apply(list_t* l, list_iterator_t func);
int list_present(list_t* l, int key);

#endif // __LIST_h__
