#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

// goal: to make a "linked list" of elements in C
typedef struct __node_t node_t;
typedef struct __list_t list_t;

// node_t -- holds elements of list
struct __node_t {
    int key;	
    node_t* next;
};

// list_t -- one of these per list
struct __list_t {
    node_t* head;
};

// methods (functions) on list_t
void list_init(list_t* l) {
    // empty list
    l->head = NULL;
}

// insert method: put something into FRONT of list
void list_insert(list_t* l, int key) {
    node_t* n = malloc(sizeof(node_t));
    assert(n != NULL);
    n->key = key;
    n->next = l->head;
    l->head = n;
}

// generic list iterator
void list_apply(list_t* l, void (*func)(int)) {
    node_t* curr = l->head;
    while (curr) {
	(*func)(curr->key);
	curr = curr->next;
    }
}




//
// main program
// 

void my_printer(int key) {
    printf("%d\n", key);
}


int main(int argc, char *argv[]) {
    list_t n;
    list_init(&n);

    int i;
    for (i = 1; i < argc; i++) 
	list_insert(&n, atoi(argv[i]));

    list_apply(&n, my_printer);

    return 0;
}

